package com.lantone.qc.trans.shaoyf;

import com.google.common.collect.Lists;
import com.lantone.qc.dbanaly.facade.shaoyf.ShaoyfXmlUtil;
import com.lantone.qc.pub.model.doc.SeriouslyIllNoticeDoc;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.trans.ModelDocTrans;
import com.lantone.qc.trans.comsis.OrdinaryAssistant;

import java.util.List;
import java.util.Map;

/**
 * @Description: 病重通知书文档生成
 * @author: rengb
 * @time: 2020/3/19 19:41
 */
public class ShaoyfSeriouslyIllNoticeDocTrans extends ModelDocTrans {

    @Override
    public List<SeriouslyIllNoticeDoc> extract(MedrecVo medrecVo) {
        List<SeriouslyIllNoticeDoc> retList = Lists.newArrayList();
        List<Map<String, Object>> contentMaps = (List) medrecVo.getContent().get("content");
        contentMaps.forEach(contentMap -> {
            retList.add(getSeriouslyIllNoticeDoc(contentMap));
        });
        return retList;
    }

    private SeriouslyIllNoticeDoc getSeriouslyIllNoticeDoc(Map<String, Object> contentMap) {
        String content = contentMap.get("xmlText").toString();
        Map<String, String> sourceMap = ShaoyfXmlUtil.getXmlToMap(content);
        sourceMap.put("mode_id=" + contentMap.get("modeId").toString(), "");
        sourceMap.put("rec_title=" + contentMap.get("recTitle").toString(), "");
        Map<String, String> structureMap = OrdinaryAssistant.mapKeyContrast(sourceMap, keyContrasts);

        SeriouslyIllNoticeDoc seriouslyIllNoticeDoc = new SeriouslyIllNoticeDoc();
        seriouslyIllNoticeDoc.setStructureMap(structureMap);
        seriouslyIllNoticeDoc.setPageData((Map) structureMap);

        return seriouslyIllNoticeDoc;
    }

    private List<String> keyContrasts = Lists.newArrayList(
            "查房记录=简要病情",
            "本人姓名=姓名"
    );

}